package net.moonleay.bedge.buttons.streakfix

import dev.kord.core.behavior.edit
import dev.kord.core.behavior.interaction.response.PublicMessageInteractionResponseBehavior
import dev.kord.core.entity.Guild
import dev.kord.core.entity.User
import dev.kord.core.entity.channel.MessageChannel
import dev.kord.core.entity.interaction.ButtonInteraction
import dev.kord.rest.builder.message.EmbedBuilder
import dev.kord.rest.builder.message.modify.embed
import net.moonleay.bedge.Bot
import net.moonleay.bedge.buttons.component.IEditButton
import net.moonleay.bedge.data.database.repository.UserRepository
import net.moonleay.bedge.util.EmbedUtil
import net.moonleay.bedge.util.Logger
import net.moonleay.bedge.util.MessageUtil

class VouchEditButton: IEditButton {
    override val id: String = "public.edit.btn.streakfix.vouch"
    override suspend fun onInteraction(
        interaction: ButtonInteraction,
        response: PublicMessageInteractionResponseBehavior,
        guild: Guild,
        user: User
    ) {
        val m = interaction.message
        val eb = MessageUtil.getAClonedEmbed(m.embeds[0])
        var shouldEditButton = false
        if (!m.embeds[0].footer?.text?.endsWith("[ongoing]")!!){
            Logger.out("This streakfix is not ongoing")
            return
        }
        val member = interaction.user.asMember(guild.id)
//        if (m.embeds[0].footer?.text?.contains(member.username)!!){
//            Logger.out("cannot vote for own streakfix")
//            return
//        }
        // do the checks and update
        if (m.embeds[0].fields[0].value.contains(user.id.value.toString())) {
            // remove the user from the 1st list in the embed
            Logger.out("Removing ${user.username} from the 1st list in the embed")
            eb.fields = EmbedUtil.replaceXWithYinValuesAtTable(user.id.value.toString(), "", eb, 1).fields
            shouldEditButton = true
        }
        if (m.embeds[0].fields[1].value.contains(user.id.value.toString())) {
            Logger.out("Removing ${user.username} from the 2nd list in the embed")
            eb.fields = EmbedUtil.replaceXWithYinValuesAtTable(user.id.value.toString(), "", eb, 2).fields
            shouldEditButton = true
        }
        if (!m.embeds[0].fields[0].value.contains(user.id.value.toString())) {
            //Add the user to the list in the embed
            Logger.out("Adding ${user.username} to the 1st list in the embed")
            eb.fields = EmbedUtil.addXToValuesAtTable(user.id.value.toString(), eb, 1).fields
            shouldEditButton = true
        }
        //Check if the vote is over
        val vouchers = EmbedUtil.getAmountOfUsersInTableX(eb, 1)
        val decliners = EmbedUtil.getAmountOfUsersInTableX(eb, 2)
        Logger.out("Vouchers = $vouchers, Decliners = $decliners")
        val target = m.embeds[0].footer?.text!!.split("{")[1].split("}")[0].toLong()
        val targetData = UserRepository.getUserByID(target)!!
        Logger.out("Target user = $target")
        val canUpdate = targetData.isAwake && targetData.currentStreak == 0
        val minvotes = 3
        if ((vouchers >= minvotes || decliners >= minvotes) && canUpdate){
            Logger.out("Voting is over")
            eb.footer?.text = m.embeds[0].footer?.text?.replace("ongoing", "voting over").toString()
            if (vouchers >= minvotes) {
                Logger.out("Vouchers won")
                val amountOfDays = m.embeds[0].author!!.name!!.split(": ")[1].toInt()
                targetData.currentStreak = amountOfDays
                if (targetData.longestStreak < amountOfDays)
                    targetData.longestStreak = amountOfDays
                UserRepository.update(targetData)
                eb.description += "\n**The vote was successful, the streak was fixed.**"
            }
            else {
                Logger.out("Decliners won")
                eb.description += "\n**The vote was unsuccessful, the streak was not fixed.**"
            }
            shouldEditButton = true
        }

        if (!canUpdate) {
            eb.footer?.text = m.embeds[0].footer?.text?.replace("ongoing", "voting over").toString()
            eb.description += "\n**The vote was canceled, because a new streak was started.**"
            shouldEditButton = true
        }


        // Finish the update
        if (shouldEditButton) {
            // update the message
            Bot.bot.kordRef.getChannelOf<MessageChannel>(interaction.channelId)!!.getMessage(m.id).edit {
                this.embed(fun EmbedBuilder.() {
                    author = eb.author
                    color = eb.color
                    title = eb.title
                    description = eb.description
                    fields = eb.fields
                    footer = eb.footer
                    author?.name = eb.author!!.name
                })
            }
        }
    }
}
